! .NOLIST
*

.IFNDEF COSWIND.DEFINED
SET COSWIND.DEFINED = 1	! Any value will do

SET COSWIN.VERSION = 2

.IFDEF C32
.IF CF.METAFILE
UNSET CF.METAFILE
!ERROR - CF.METAFILE features not supported in Comet32
.ENDIF
.ENDIF

.IFDEF CF.MODELESS.CODE
  .IFNDEF CF.DIALOG.USED
  SET CF.DIALOG.USED		= 1
  .ENDIF
.ENDIF

.IFDEF CF.MODAL.CODE
  .IFNDEF CF.DIALOG.USED
  SET CF.DIALOG.USED		= 1
  .ENDIF
.ENDIF


Include "CosUtl.Inc"		! Utility decaratives
Include "FileFind.Inc"	! File Finder decaratives
Include "CosWSS.Inc"		! Session status
Include "Windows.Inc"	! Windows decaratives

.IFDEF	CF.TABCTRL.CODE
Include "CosTabs.Inc"
.ENDIF
.IFDEF CF.CALENDAR.CODE
Include "CosCal.Inc"
.ENDIF
.IFDEF CF.DATETIME.CODE
Include "CosTime.Inc"
.ENDIF
.IFDEF CF.SPIN.CODE
Include "CosSpin.Inc"
.ENDIF
.IFDEF CF.SLIDER.CODE
Include "CosSlide.Inc"
.ENDIF
.IFDEF CF.IPADDR.CODE
Include "CosIpAdr.Inc"
.ENDIF
.IFDEF CF.PROGRESS.CODE
Include "CosProg.Inc"
.ENDIF
.IFDEF CF.SCROLL.CODE
Include "CosScrl.Inc"
.ENDIF
.IFDEF CF.MOVIE.CODE
Include "CosMovie.Inc"
.ENDIF



!==========================================================
!==========================================================
! BEGIN OF GENERAL PUROPOSE DIALOG DECLARATIONS
!==========================================================
!==========================================================

SET	DRIVERNAME$ = "COSWIN"

!
! cosOD  - Out Data Structure
! cosOCD - Out Dialog Commands
! cosOV	 - Out General Function Values
! cosOVW - Out Window Commands
! cosOVM - Out Menu Commands
!
! cosID - In Data Structure
! cosIV - In Return Values
!
!


!==========================================================
! INPUT return values
!==========================================================
SET	cosIV.SUCCESS		= 0
SET	cosIV.INVFUNC		= 1
SET	cosIV.DLGFAILED		= 2
SET	cosIV.DLGMESSAGE	= 3
SET	cosIV.DLGCLOSED		= 4

SET	WM.DLG.TRACKED		= 1424	! WM_USER+400
SET	WM.DLG.TRACKMOUSE	= 1425	! WM_USER+401


!==========================================================
! Special message for setting tab control background color
!==========================================================
Set WM.SETTABBKCOLOR = 1024

!==========================================================
! OUTPUT function values
!==========================================================
SET	cosOV.LOADDLL$		= "@0000@"	! INTEL(0)
SET	cosOV.UNLOADDLL$	= "@0100@"	! INTEL(1)
SET	cosOV.EXECUTEDLG$	= "@0200@"	! INTEL(2)
SET	cosOV.DESTROYDLG$	= "@0300@"	! INTEL(3)
SET	cosOV.CMDDIALOG$	= "@0400@"	! INTEL(4)
SET	cosOV.INITMSGFILTER$	= "@0500@"	! INTEL(5)
SET	cosOV.ADDTOMSGFILTER$	= "@0600@"	! INTEL(6)
SET	cosOV.INITCMDFILTER$	= "@0700@"	! INTEL(7)
SET	cosOV.ADDTOCMDFILTER$	= "@0800@"	! INTEL(8)
SET	cosOVW.GETVIEWWND$	= "@0900@"	! INTEL(9)
SET	cosOVW.GETWINDOWTEXT$	= "@0A00@"	! INTEL(10)
SET	cosOVW.UPDATEWINDOW$	= "@0B00@"	! INTEL(11)
SET	cosOVW.ISWINDOWENABLED$	= "@0C00@"	! INTEL(12)
SET	cosOVW.ENABLEWINDOW$	= "@0D00@"	! INTEL(13)
SET	cosOVW.SHOWWINDOW$	= "@0E00@"	! INTEL(14)
SET	cosOVW.GETFOCUS$	= "@0F00@"	! INTEL(15)
SET	cosOVW.SETFOCUS$	= "@1000@"	! INTEL(16)
SET	cosOVW.SETWINDOWTEXT$	= "@1100@"	! INTEL(17)
SET	cosOVW.SENDMESSAGE$	= "@1200@"	! INTEL(18)
SET	cosOVW.GETMENU$		= "@1300@"	! INTEL(19)
SET	cosOVW.SETMENU$		= "@1400@"	! INTEL(20)
SET	cosOVM.CREATEMENU$	= "@1500@"	! INTEL(21)
SET	cosOVM.CREATEPOPUPMENU$	= "@1600@"	! INTEL(22)
SET	cosOVM.LOADMENU$	= "@1700@"	! INTEL(23)
SET	cosOVM.DESTROYMENU$	= "@1800@"	! INTEL(24)
SET	cosOVM.APPENDMENU$	= "@1900@"	! INTEL(25)
SET	cosOVM.CHECKMENUITEM$	= "@1A00@"	! INTEL(26)
SET	cosOVM.DELETEMENU$	= "@1B00@"	! INTEL(27)
SET	cosOVM.ENABLEMENUITEM$	= "@1C00@"	! INTEL(28)
SET	cosOVM.GETMENUITEMCOUNT$= "@1D00@"	! INTEL(29)
SET	cosOVM.GETMENUITEMID$	= "@1E00@"	! INTEL(30)
SET	cosOVM.GETMENUSTATE$	= "@1F00@"	! INTEL(31)
SET	cosOVM.GETMENUSTRING$	= "@2000@"	! INTEL(32)
SET	cosOVM.GETSUBMENU$	= "@2100@"	! INTEL(33)
SET	cosOVM.INSERTMENU$	= "@2200@"	! INTEL(34)
SET	cosOVM.MODIFYMENU$	= "@2300@"	! INTEL(35)
SET	cosOVM.REMOVEMENU$	= "@2400@"	! INTEL(36)
SET	cosOVW.DRAWMENUBAR$	= "@2500@"	! INTEL(37)
SET	cosOVW.POSWINDOW$	= "@2600@"	! INTEL(38)
SET	cosOVW.FINDUSERID$	= "@2700@"	! INTEL(39)
SET	cosOVW.CLEARSESSION$	= "@2800@"	! INTEL(40)
SET	cosOVW.MESSAGEBOX$	= "@2900@"	! INTEL(41)
SET	cosOVW.GETPARENT$	= "@2A00@"	! INTEL(42)
SET	cosOVW.CREATECONTROL$	= "@2B00@"	! INTEL(43)
SET	cosOVW.DESTROYCONTROL$	= "@2C00@"	! INTEL(44)
SET	cosOVW.DESTROYALLCONTROLS$	= "@2D00@"	! INTEL(45)
SET	cosOVM.TRACKPOPUPMENU$  = "@2E00@"	! INTEL(46)
SET	cosOV.REMOVEFROM.MSGFILTER$ = "@2F00@"	! INTEL(47)
SET	cosOV.REMOVEFROM.CMDFILTER$ = "@3000@"	! INTEL(48)
SET	cosOVW.POSTMESSAGE$	= "@3100@"	! INTEL(49)
SET	cosOV.LOADMENUCONTEXT$	= "@3200@"	! INTEL(50)
SET	cosOV.BEGINTRACKING$	= "@3300@"	! INTEL(51)
SET	cosOV.ENDTRACKING$	= "@3400@"	! INTEL(52)
SET	cosOV.TRACKCONTROL$	= "@3500@"	! INTEL(53)
SET	cosOVW.GETFRAMEWND$	= "@3600@"	! INTEL(54)
SET	cosOV.SETCLIENTSIZE$	= "@3700@"	! INTEL(55)
SET	cosOVW.MAPDIALOGRECT$	= "@3800@"	! INTEL(56)
SET	cosOVW.GETWINDOWRECT$	= "@3900@"	! INTEL(57)
SET	cosOVW.GETCLIENTRECT$	= "@3A00@"	! INTEL(58)
SET	cosOVW.MOVEWINDOW$	= "@3B00@"	! INTEL(59)
SET	cosOVW.CLIENTTOSCREEN$	= "@3C00@"	! INTEL(60)
SET	cosOVW.SCREENTOCLIENT$	= "@3D00@"	! INTEL(61)
SET	cosOVW.CREATEFONT$	= "@3E00@"	! INTEL(62)
SET	cosOVW.DELETEOBJECT$	= "@3F00@"	! INTEL(63)
SET	cosOVW.GETTEXTEXTENT$	= "@4000@"	! INTEL(64)
SET	cosOVW.SETVIEWFONT$	= "@4100@"	! INTEL(65)
SET	cosOVW.SETCAPTION$	= "@4200@"	! INTEL(66)
SET	cosOVW.SETSTATUSMESSAGE$= "@4300@"	! INTEL(67)
SET	cosOVW.GETRESULT$	= "@4400@"	! INTEL(68)
SET	cosOVW.INVALIDATERECT$	= "@4500@"	! INTEL(69)
SET	cosOVW.SETWINDOWPOS$	= "@4600@"	! INTEL(70)
SET	cosOVW.SIZEVIEWTOWINDOW$ = "@4700@"	! INTEL(71)
SET	cosOVW.CHILDHASFOCUS$	= "@4800@"	! INTEL(72)
SET	cosOVW.MAPCOSWRECT$	= "@4900@"	! INTEL(73)
SET	cosOVW.GETCOSWUNITS$	= "@4A00@"	! INTEL(74)
SET	cosOVW.GETDIALOGUNITS$	= "@4B00@"	! INTEL(75)
SET	cosOVW.GETTOOLBARSIZE$	= "@4C00@"	! INTEL(76)
SET	cosOVW.GETTOOLCWND$		= "@4D00@"	! INTEL(77)
SET	cosOVW.ISMAXIMIZED$		= "@4E00@"	! INTEL(78)
SET	cosOVW.ISMINIMIZED$		= "@4F00@"	! INTEL(79)
SET	cosOVW.ENABLETOOLBAR$	= "@5000@"	! INTEL(80)
SET	cosOVW.ENABLESTATUSBAR$	= "@5100@"	! INTEL(81)
SET	cosOVM.HILITEMENUITEM$	= "@5200@"	! INTEL(82)
SET	cosOV.TVINSERTITEM$		= "@5300@"	! INTEL(83)
SET	cosOV.INITNOTIFYFILTER$		= "@5400@"	! INTEL(84)
SET	cosOV.ADDTONOTIFYFILTER$	= "@5500@"	! INTEL(85)
SET	cosOV.REMOVEFROM.NOTIFYFILTER$	= "@5600@"	! INTEL(86)
SET	cosOVW.SETPARENT$		= "@5700@"	! INTEL(87)
SET	cosOV.TVGETITEM$		= "@5800@"	! INTEL(88)
SET	cosOV.TVSETITEM$		= "@5900@"	! INTEL(89)
SET	cosOVW.GETSYSTEMMENU$		= "@5a00@"	! INTEL(90)
SET	cosOVW.SETSCROLLRANGE$		= "@5b00@"	! INTEL(91)
SET	cosOVW.SETSCROLLPOS$		= "@5c00@"	! INTEL(92)
SET	cosOVW.GETSCROLLPOS$		= "@5d00@"	! INTEL(93)
SET	cosOVW.GETSCROLLRANGE$		= "@5e00@"	! INTEL(94)
SET	cosOVW.GETSYSTEMMETRICS$	= "@5f00@"	! INTEL(95)
SET	cosOVW.GETSYSCOLOR$		= "@6000@"	! INTEL(96)
SET	cosOVW.PLAYSOUND$			= "@6100@"	! INTEL(97)
SET	cosOV.TCINSERTITEM$		= "@6200@"	! INTEL(98)
SET	cosOV.TCSETITEM$			= "@6300@"	! INTEL(99)
SET	cosOV.TCGETITEM$			= "@6400@"	! INTEL(100)

SET	cosOV.GDIFUNC$				= "@6500@"	! INTEL(101)
SET	cosOV.GDIBIGFUNC$			= "@6600@"	! INTEL(102)

SET	cosOV.ASYNCNOTIFYENABLE$	= "@6700@"	! INTEL(103)
SET	cosOV.INITNOTIFYFILTER2$	= "@6800@"	! INTEL(104)
SET	cosOV.ADDTONOTIFYFILTER2$	= "@6900@"	! INTEL(105)

SET	cosOVW.GETWINDOWLONG$	= "@7200@"	! INTEL(114)
SET	cosOVW.SETWINDOWLONG$	= "@7300@"	! INTEL(115)
SET	cosOVW.ISWINDOWVISIBLE$	= "@7400@"	! INTEL(116)

SET	cosOV.LVINSERTCOLUMN$	= "@7500@"	! INTEL(117)
SET	cosOV.LVINSERTITEM$		= "@7600@"	! INTEL(118)
SET	cosOV.LVSETITEMTEXT$		= "@7700@"	! INTEL(119)
SET	cosOV.LVSETITEM$			= "@7800@"	! INTEL(120)
SET	cosOV.LVGETITEM$			= "@7900@"	! INTEL(121)
SET	cosOV.LVSORTITEMS$		= "@7A00@"	! INTEL(122)
SET	cosOV.LVSETCOLUMNWIDTH$	= "@7B00@"	! INTEL(123)	! New
SET	cosOV.LVSETCOLUMN$		= "@7C00@"	! INTEL(124)	! New

SET	cosOVW.GETCENTUNITS$		= "@7D00@"	! INTEL(125)	! New
SET	cosOVW.MAPCENTRECT$		= "@7E00@"	! INTEL(126)	! New
SET	cosOVW.LOADIMAGE$			= "@7F00@"	! INTEL(127)	! New
SET	cosOVW.SETCLASSLONG$		= "@8000@"	! INTEL(128)	! New
SET	cosOVW.GETCLASSLONG$		= "@8100@"	! INTEL(129)	! New
SET	cosOVW.GETTOOLITEMSTATE$	= "@8200@"	! INTEL(130)	! New
SET	cosOVW.SETTOOLITEMSTATE$	= "@8300@"	! INTEL(131)	! New
SET	cosOVW.TABADJUSTRECT$		= "@8400@"	! INTEL(132)	! New
SET cosOVM.CHOOSECOLOR$			= "@8500@"	! INTEL(133)	! New
SET cosOVM.CHOOSEFILE$			= "@8600@"	! INTEL(134)	! New
SET cosOVM.CFSETDEFEXT$			= "@8700@"	! INTEL(135)	! New
SET cosOVM.CFSETFILTER$			= "@8800@"	! INTEL(136)	! New
SET cosOVM.CHOOSEFOLDER$		= "@8900@"	! INTEL(137)	! New
SET cosOVM.TRACKPOPUPMENUEX$	= "@8A00@"	! INTEL(138)	! New
SET	cosNMHDR.LENGTH = 12

!==========================================================
! OUTPUT dialog commands
!==========================================================
SET	cosOCD.ENDDLG$		= "@0A00@"	! INTEL(10) - EndDialog(hDlg, CmdId)
SET	cosOCD.SETTEXT$		= "@0B00@"	! INTEL(11) - SetDlgItemText(hDlg, CtrlId, Text)
SET	cosOCD.GETTEXT$		= "@0C00@"	! INTEL(12) - GetDlgItemText(hDlg, CtrlId, Text, 254)
SET	cosOCD.GETDLGITEM$	= "@0D00@"	! INTEL(13) - GetDlgItem(hDlg, CtrlId)
SET	cosOCD.CHECKBUTTON$	= "@0E00@"	! INTEL(14) - CheckDlgButton(hDlg, CtrlId, State)
SET	cosOCD.ISBUTTONCHECKED$	= "@0F00@"	! INTEL(15) - IsDlgButtonChecked(hDlg, CtrlId)
SET	cosOCD.CHECKRADIOBUTTON$= "@1000@"	! INTEL(16) - CheckRadioButton(hDlg, FirstCtrlId, LastCtrlId, State)
SET	cosOCD.GETCHECKEDRADIOBUTTON$ = "@1100@"	! INTEL(17) - GetCheckedRadioButton(hDlg, FirstCtrlId, LastCtrlId, State)
SET	cosOCD.PBAUTOLOAD$	= "@1200@"	! INTEL(18) - COSW - AutoLoad a bitmapped pushbutton
SET	cosOCD.PBLOAD$		= "@1300@"	! INTEL(19) - COSW - Load a bitmapped pushbutton
SET	cosOCD.DIBATTACH$	= "@1400@"	! INTEL(20) - Attach a DIB to specified control
SET	cosOCD.SENDDLGITEMMESSAGE$ = "@1500@"	! INTEL(21) - SendDlgItemMessage(hDlg, CtrlId, wParam, lParam)
SET	cosOCD.DLGITEMFOCUS$	= "@1600@"	! INTEL(22) - SetFocus(GetDlgItem(CtrlId))
SET	cosOCD.ENABLEDLGITEM$	= "@1700@"	! INTEL(23) - EnableWindow(GetDlgItem(CtrlId), wParam)
SET	cosOCD.SHOWDLGITEM$	= "@1800@"	! INTEL(24) - ShowWindow(GetDlgItem(CtrlId), wParam)
SET	cosOCD.GETDLGITEMTEXTLENGTH$ = "@1900@"	! INTEL(25) - SendMessage(GetDlgItem(CtrlId), WM_GETTEXTLENGTH, 0, 0)
SET	cosOCD.LISTADDSTRING$	= "@1A00@"	! Intel(26)
SET	cosOCD.COMBOADDSTRING$	= "@1B00@"	! Intel(27)
SET	cosOCD.SETTIMER$			= "@1C00@"	! Intel(28)
SET	cosOCD.KILLTIMER$			= "@1D00@"	! Intel(29)
SET	cosOCD.LISTSETHORIZEXTENT$	= "@1E00@"	! Intel(30) - New
SET	cosOCD.LISTSETTABSTOPS$		= "@1F00@"	! Intel(31) - New
SET	cosOCD.STATICSETATTR$		= "@2000@"	! Intel(32) - New
SET	cosOCD.ENABLEENTERADVANCE$	= "@2100@"	! Intel(33) - New
SET	cosOCD.ATTACHNUMERICEDIT$	= "@2200@"	! Intel(34) - New
SET	cosOCD.ATTACHMASKEDEDIT$	= "@2300@"	! Intel(35) - New
SET	cosOCD.SETTABNOTIFY$		= "@2400@"	! Intel(36) - New

!==========================================================
! Dialog control constants
!==========================================================

!==========================================================
!
SET	cosCDB.BTNOFF		= 0
SET	cosCDB.BTNON		= 1
SET	cosCDB.BTNGRAY		= 2
!
! For calls to BTN.CHECK, BTN.STATE
!
!==========================================================

!==========================================================
Set NE.CannotBeNegative					= 0x1000
Set NE.AddDecimalAfterMaxWholeDigits	= 0x2000
Set NE.PadDecimalWhenTextChanges	= 0x4000
Set NE.PadWhenTextIsSet				= 0x8000

Set NE.Beep.IfInvalid				= 0x0001
Set NE.Beep.IfEmpty					= 0x0002
Set NE.Beep							= 0x0003
Set NE.SetValid.IfInvalid			= 0x0004
Set NE.SetValid.IfEmpty				= 0x0008
Set NE.SetValid						= 0x000C
Set NE.SetFocus.IfInvalid			= 0x0010
Set NE.SetFocus.IfEmpty				= 0x0020
Set NE.SetFocus						= 0x0030
Set NE.ShowMessage.IfInvalid		= 0x0050
Set NE.ShowMessage.IfEmpty			= 0x00A0
Set NE.ShowMessage					= 0x00F0

Set NE.PadWithZerosBeforeDecimal	= 0x0100
Set NE.PadWithZerosAfterDecimal		= 0x0200
Set NE.DontPadWithZerosIfEmpty		= 0x0400
Set NE.RemoveExtraLeadingZeros		= 0x0800
!==========================================================

!==========================================================
!
SET	cosPIC.CROP				= 0
SET	cosPIC.STRETCH			= 1
SET	cosPIC.TRANSPARENT	= 2
!
! For calls to LOAD.DIBPIC
!
!==========================================================

!==========================================================
!
SET	cosBTNPIC.USECTLID = 0
SET	cosBTNPIC.USECTLCWND = 1
SET	cosBTNPIC.STRETCHPIC = 4	! on-the-fly only
SET	cosBTNPIC.LOADFROMFILE = 8
SET	cosBTNPIC.CROPPIC = 16		! on-the-fly only
!
! For calls to COS.LoadWndButtonPic
!
!==========================================================


!==========================================================
!
SET	cosLIST.HASDATA		= 1
!
! For calls to COS.ListAddStringID
!
!==========================================================

!==========================================================
!
SET cosTPM.NOAUTOCONVERT = 64
!
! For calls to COS.TrackPopupMenu & COS.TrackPopupMenuEx
!
!==========================================================

!==========================================================
!
SET	cosCOMBO.HASDATA	= 1
!
! For calls to COS.ComboAddStringID
!
!==========================================================

!==========================================================
!
SET	cosSND.SYNC			= 0  !/* play synchronously (default) */
SET	cosSND.ASYNC		= 1  !/* play asynchronously */
SET	cosSND.NODEFAULT	= 2  !/* silence (!default) if sound not found *
SET	cosSND.LOOP			= 8  !/* loop the sound until next sndPlaySound
SET	cosSND.NOSTOP		= 16 ! /* don't stop any currently playing sound

SET	cosSND.NOWAIT		= 8192 !/* don't wait if the driver is busy */
SET	cosSND.FILENAME	= 131072 !/* name is file name */
SET	cosSND.PURGE		= 64  !/* purge non-static events for task */
!
! For calls to COS.PlaySound
!
!==========================================================


!==========================================================
! Window control constants
!==========================================================

!==========================================================
!
SET	cosCTL.QCRTUNITS = 1	!Row/Col & Width/Height are QCRT Rows\Col
SET	cosCTL.RCQCRT	= 1	!Row/Col/Width/Height are QCRT Rows\Col

SET	cosCTL.COSWUNITS = 4	!Window coordinates/size are local font units
SET	cosCTL.RCCOSWUNITS = 4	!Row/Col/Width/Height are local font units

.IFDEF WINGID.DEFINED
SET	cosCTL.CENTIUNITS	= 2	!Row/Col/Width/Height are QCRT font/100 units
SET	cosCTL.NOFOCUS = 8	!Button Focus returns to view upon leaving
.ELSE
SET	cosCTL.WHCOSWUNITST = 8	!Width/Height are local font units
SET	cosCTL.WHQCRT	= 2	!Width/Height are QCRT /Rows/Col
.ENDIF

SET	cosCTL.COSCOLOR = 16	!Color maps to COMET color
SET	cosCTL.RGBCOLOR = 32	!Color is COLORREF color
SET	cosCTL.PICTURECTRL = 64	!Displays a picture
SET	cosCTL.FONTNOTENTHPT = 64	!Font is in pixels

SET	cosCTL.DLGWUNITS = 128  !Row/Col are dialog units
SET	cosCTL.RCDLGWUNITS = 128  !Row/Col/Width/Height are dialog units
!SET	cosCTL.WHDLGWUNITST = 0 !Width/Height are dialog units

SET	cosCTL.USESEXTSTYLE = 512 !Control uses extended style
SET	cosCTL.RCNOMARGINS = 1024 !Ignore margins
SET	cosCTL.PARENTSPECIFIED = 2048 !Font is parent window
SET	cosCTL.LOCKFONT = 4096 !Don't auto-change font
SET	cosCTL.LOCKSIZE = 8192 !Don't auto-change size
!SET	cosCTL.LOCKPOS = 16384 !Don't auto-change position
SET	cosCTL.EXTFLAGS = 16384 !ExtFlags is valid
SET	cosCTL.FLYBYBTN = 32768 !Fly-by button
!
! cosDlgFlags for calls to COS.CreateControl
!
!==========================================================


!==========================================================
!
! Additional edit control messages
!
SET	cosEN.LOSTFOCUS		= 513	! EN.KILLFOCUS+1
! This message is a "delayed" version of the EN.KILLFOCUS
! message.  Apparently Windows is not stable enough when the
! EN.KILLFOCUS message is sent so this method is recommended
! when validation is necessary.
!==========================================================


!==========================================================
!
SET	cosEW.ENABLE		= 1
SET	cosEW.DISABLE		= 0
!
! For calls to COS.EnableWindow, COS.IsWindowEnabled, and
!	       COS.EnableDlgItem
!
!==========================================================

!==========================================================
!
SET	cosIR.ERASEBKG		= 1
SET	cosIR.ENTIREWIN		= 2
!
! For calls to COS.InvalidateRect and COS.InvalidateWindow
!
!==========================================================

!==========================================================
!
SET cosTIS.DISABLE = 0
SET cosTIS.ENABLE = 1
! TOOL Item States for tools loaded in menu and toolbar
!
!==========================================================


!==========================================================
!
! Pre-defined system functions
!
!==========================================================
SET	cosABOUT.DIALOG		= 101

SET	cosNEW.SESSION		= 33001
SET	cosPRINT.SESSION	= 33002
SET	cosFONT.DIALOG		= 33003
SET	cosCOLOR.DIALOG		= 33004
SET	cosMAXSESSION.DIALOG	= 33005


!==========================================================
!
LENGTH   2    & LOCAL cosDOSRWFunc$		! DOSRW function to call
SET	cosWINSENDCMD$		= "@FFF7@"	! Send data
SET	cosWINSENDGETCMD$	= "@FFF1@"	! Send then receive data
SET	cosWINRECEIVECMD$	= "@FFF8@"	! Receive data
SET	cosWINSTATUSCMD$	= "@FFF2@"	! Receive status
SET	cosWINTASKBREAKCMD$	= "@FFF6@"	! Take a Task-Break
SET	cosWINMETAFILECMD$	= "@FFE9@"	! VMF Function
SET	cosWINMETAFILEWRITECMD$	= "@FFE8@"	! VMF Write
SET	cosCOSCMISCFUNC$	= "@FFE0@"	! COSC Miscellaneous functions
SET	cosCOSCSHOWSTATUSMSG$ = "@FFEE@"	! COSC ShowStatusMsg
SET	cosCOSCHIDESTATUSMSG$ = "@FFEF@"	! COSC HideStatusMsg

SET	cosWINSENDDBGMSG$	= "@FFF5@"	! Send debugger message
SET	cosWINSENDWINMSG$	= "@FFF0@"	! Send dbg msg to 'windows' window

!===================================
! New COSWIN all-in-one cache functions
SET	cosWINSENDCACHECMD$		= "@FFDA@"	! Send data (cache as req)
SET	cosWINSENDCACHECMD.RES$	= "@FFD9@"	! Flush, Send data get 32 bit result (no cache)
SET	cosWINSENDGETCACHECMD$	= "@FFD8@"	! Flush, Send and receive data (no cache)

!
! for calls to DOSRW
!
! Used by: COS.SEND, COS.SNDGET, COS.RECEIVE,
!	   COS.STATUS, COS.TASKBREAK
!
!==========================================================


!==========================================================
!
LENGTH	254  & LOCAL cosDllNames$	! Name of DLL to open
LENGTH	3    & LOCAL cosDllDir$		! Comet directory
LENGTH	1.0  & LOCAL cosDllOpen		! TRUE if open was successful
!
! for calls to OPEN.DLL
!
!==========================================================

!==========================================================
!
LENGTH	10.0 & LOCAL cosDlgId		! ID of dialog to open !UINT.N.LEN
LENGTH	5.0  & LOCAL cosDlgFlags	! Open flags (MODAL/MODELESS)
LENGTH	5.0  & LOCAL cosDlgExtFlags ! Call specific flags
LENGTH	10.0 & LOCAL cosDlgUserID	! User assigned ID !UINT.N.LEN
LENGTH	1.0  & LOCAL cosDlgOpen		! TRUE if open was successful
LENGTH	HANDLE.S.LEN & LOCAL cosDlghDlg$	! Handle of dialog

SET	MAX.DLG.RECUR	= 5
LENGTH	1.0  & LOCAL cosDlgLevel	! Index of current dialog
LENGTH	1.0  & LOCAL cosSavedDlgLevel(MAX.DLG.RECUR)
LENGTH	10.0 & LOCAL cosSavedDlgId(MAX.DLG.RECUR) !UINT.N.LEN
LENGTH	5.0  & LOCAL cosSavedDlgFlags(MAX.DLG.RECUR)
LENGTH	10.0 & LOCAL cosSavedDlgUserID(MAX.DLG.RECUR) !UINT.N.LEN
LENGTH	1.0  & LOCAL cosSavedDlgOpen(MAX.DLG.RECUR)
LENGTH	HANDLE.S.LEN & LOCAL cosSavedDlghDlg$(MAX.DLG.RECUR)

!
! for calls to OPEN.DLG
!
!==========================================================



!==========================================================
!
! cosError values
!
SET	NOERROR		= 0
SET	NODIALOG	= 1
SET	BADINITDIALOG	= 2
SET	FILENOTFOUND	= 3
SET	DIALOGOVERFLOW	= 4
SET	DIALOGUNDERFLOW	= 5
SET	WRONGVERSION	= 6
SET	METAFILEMODE	= 7
LENGTH 2.0 & LOCAL cosError
LENGTH 254 & LOCAL cosError$ ! Passed to ERROR.HANDLER
!
! Used by STD.DLG.INIT (DO.DIALOG, DO.MODELESS, DO.MODAL, EXECUTE.DLG)
! Passed to USER supplied ERROR.HANDLER
!
!==========================================================

! Virtual Memory File stuff

SET cosVMF.CREATE$		= "@0000@"
SET cosVMF.DESTROY$		= "@0100@"
SET cosVMF.SAVE$		= "@0200@"
SET cosVMF.LOAD$		= "@0300@"
SET cosVMF.SEND$		= "@0400@"
SET cosVMF.EXECUTE$		= "@0A00@"
SET cosVMF.DESTROYREMOTE$	= "@0B00@"
SET cosVMF.SAVEREMOTE$		= "@0C00@"
SET cosVMF.LOADREMOTE$		= "@0D00@"

.IF CF.METAFILE
LENGTH	DWORD.S.LEN & LOCAL cosVMFFuncResult$
LENGTH	WORD.S.LEN & LOCAL cosVMF.ActHandle$	! Currently active VMF handle
LENGTH	WORD.S.LEN & LOCAL cosVMF.Handle$	! VMF handle
LENGTH	WORD.S.LEN & LOCAL cosVMF.SaveHandle$	! VMF handle
LENGTH	WORD.S.LEN & LOCAL cosVMF.RemHandle$	! Remote VMF handle
LENGTH  WORD.S.LEN & LOCAL cosVMF.Func$		! Function
LENGTH  WORD.S.LEN & LOCAL cosVMF.Flags$	! Flags
LENGTH  WORD.N.LEN & LOCAL cosVMFInfoSize	! Size of buffer
SET COS.VMF.BASE.SIZE = 6 ! WORD.S.LEN+WORD.S.LEN+HANDLE.S.LEN
cosVMFInfo: Format cosVMF.Func$;cosVMF.Flags$;cosVMF.Handle$;cosFileSpec$
SET VMF.SEND.SAVE = 0
SET VMF.SEND.EXECUTE = 1
.ENDIF

! Miscelaneous stuff

Length 1.0 & Local cosDidInit
LENGTH  1.0 & LOCAL cosTrace
LENGTH	2.0 & LOCAL cosTraceLun
LENGTH	WPARAM.S.LEN & LOCAL coswParam$
LENGTH	10.0 & LOCAL coswParam	!WPARAM.N.LEN
LENGTH	LPARAM.S.LEN & LOCAL coslParam$
LENGTH	10.0 & LOCAL coslParam	!LPARAM.N.LEN

LENGTH	10.0 & LOCAL cosCtlId !UINT.N.LEN
LENGTH	10.0 & LOCAL cosCtlIdEx !UINT.N.LEN
LENGTH	HANDLE.S.LEN & LOCAL cosCtlCWnd$
LENGTH	HANDLE.S.LEN & LOCAL cosHObject$
LENGTH	MAX.STRING.LEN & LOCAL cosCtlText$

LENGTH	10.0 & LOCAL cosCommand !UINT.N.LEN
LENGTH	10.0 & LOCAL cosMessage !UINT.N.LEN
LENGTH	UINT.S.LEN & LOCAL cosMessage$
LENGTH	WORD.S.LEN & LOCAL cosFlags$		! WORD

LENGTH	HANDLE.S.LEN & LOCAL cosCWnd$

LENGTH	5.0  & LOCAL cosState
LENGTH	10.0  & LOCAL cosStart
LENGTH	10.0  & LOCAL cosEnd
LENGTH	10.0 & LOCAL cosCode	!UINT.N.LEN
LENGTH	10.0  & LOCAL cosFlags

LENGTH	WORD.S.LEN & LOCAL cosFunction$	! WORD

LENGTH	10.0 & LOCAL cosItemId !UINT.N.LEN
LENGTH	10.0 & LOCAL cosItemState !UINT.N.LEN

LENGTH	10.0 & LOCAL cosSubItem !UINT.N.LEN
LENGTH	10.0 & LOCAL cosItemSize !UINT.N.LEN
LENGTH	10.0 & LOCAL cosItemCount !UINT.N.LEN

LENGTH	10.0 & LOCAL cosDlgResult !UINT.N.LEN

LENGTH	DWORD.S.LEN & LOCAL cosFuncResult$
LENGTH	5.0 & LOCAL cosFuncLoResult !WORD.N.LEN
LENGTH	5.0 & LOCAL cosFuncHiResult !WORD.N.LEN
LENGTH	10.0 & LOCAL cosFuncResult !DWORD.N.LEN

LENGTH	10.0 & LOCAL cosX, cosY	!LONG.N.LEN

LENGTH	3.0 & LOCAL cosRed, cosGreen, cosBlue
LENGTH	10.0 & LOCAL cosMin, cosMax, cosPos, cosIndex, cosValue
LENGTH	10.0 & LOCAL cosCol, cosRow, cosWidth, cosHeight
LENGTH	10.0 & LOCAL cosLeft, cosTop, cosRight, cosBottom
LENGTH	10.0 & LOCAL cosStyle !DWORD.N.LEN
LENGTH	10.0 & LOCAL cosExStyle !DWORD.N.LEN
LENGTH	10.0 & LOCAL cosForeColor, cosBackColor, cosGrayColor !DWORD.N.LEN
LENGTH	HANDLE.N.LEN & LOCAL cosHFont
LENGTH	HANDLE.N.LEN & LOCAL cosHGdiObj

SET CLASSNAME.SIZE = 32
LENGTH	CLASSNAME.SIZE   & LOCAL cosClassName$

Length 1.0 & Local cosCheckResult, cosGetResult

.IFNDEF SYSDATA.DEFINED
SET SYSDATA.DEFINED = 1
LENGTH	MAX.STRING.LEN & LOCAL cosSysData$	! Used by low level subs
LENGTH 3.0 & LOCAL cosSysDataLen
cosSysDataStruct: Format cosSysData$
.ENDIF

.IFDEF	TRACE.CALLS
.IFNDEF	TRACE.ENABLED
SET TRACE.ENABLED = 1
.ENDIF
.ENDIF

.IFDEF	TRACE.RECEIVE
.IFNDEF	TRACE.ENABLED
SET TRACE.ENABLED = 1
.ENDIF
.ENDIF

.IFDEF	TRACE.ENABLED
LENGTH	MAX.STRING.LEN & LOCAL CosProc$
LENGTH	MAX.STRING.LEN & LOCAL CosProcMsg$
LENGTH	MAX.STRING.LEN & LOCAL CosDebugMsg$
LENGTH	10.0 & LOCAL CosDebug.PrevFuncResult !DWORD.N.LEN
LENGTH	10.0 & LOCAL CosDebug.PrevCtlId !UINT.N.LEN
LENGTH	5.0  & LOCAL CosDebug.PrevStart
LENGTH	5.0  & LOCAL CosDebug.PrevEnd
LENGTH  1.0 & LOCAL InsideDebug
.ENDIF
SET DEBUG.IDENTFIER = 110378	! Great day in Oakland!
SET DEBUG.DLG.ID = 129
SET DEBUG.EDITCTL.ID = 1000
SET DEBUG.TRACE.DLL$ = "TRACEWIN.DLL"

!==========================================================
! STATUS structure members
!==========================================================
LENGTH	2   & LOCAL cosStatus.Data$	! WORD
cosStatus:	Format  cosStatus.Data$
SET cosStatusStrucSize = 2


!==========================================================
! INPUT structure members
!==========================================================
LENGTH	WORD.S.LEN & LOCAL cosID.Function$	! WORD
LENGTH	HANDLE.S.LEN & LOCAL cosID.hDlg$	! HANDLE (LENGTH 4 for 32 bit)
LENGTH	UINT.S.LEN & LOCAL cosID.Msg$		! UINT
LENGTH	WPARAM.S.LEN & LOCAL cosID.wParam$	! WPARAM
LENGTH	MAX.STRING.LEN & LOCAL cosID.lParam$	! LPARAM
SET	cosIDStrucSize = 268		! TOTAL

cosID:	Format	  _
	cosID.Function$	; _
	cosID.hDlg$	; _
	cosID.Msg$	; _
	cosID.wParam$	; _
	cosID.lParam$


!==========================================================
! OUTPUT structure members
!==========================================================

! cosOD.Flags$ values

! Dialog execute flags - cosDlgFlag
SET DLGMODELESS		= 0		! Execute modeless dialog
SET DLGMODAL		= 1		! Execute modal dialog
SET DLGISASYNC		= 2		! Execute dialog using Async event handler
SET DLGAUTOMODE		= 4		! Execute dialog aut-determine if modeless (WS_CHILD & parent is view)

! SendDlgItemMessage and SendMessage
SET LPARAMDWORD$	= "@0100@"	! INTEL(1) - lParam contains a DWORD
SET LPARAMCOPY$		= "@0200@"	! INTEL(2) - Copy lparam into result structure


LENGTH  WORD.N.LEN & LOCAL cosOD.DataSize	! TOTAL length of all data
LENGTH	WORD.S.LEN & LOCAL cosOD.Function$	! WORD
LENGTH	HANDLE.S.LEN & LOCAL cosOD.hDlg$	! HANDLE (LENGTH 4 for 32 bit)
LENGTH	WORD.S.LEN & LOCAL cosOD.Cmd$		! WORD
LENGTH	WORD.S.LEN & LOCAL cosOD.Flags$	! WORD
LENGTH	UINT.S.LEN & LOCAL cosOD.nID$		! INT
LENGTH	UINT.S.LEN & LOCAL cosOD.Msg$		! UINT
LENGTH	WPARAM.S.LEN & LOCAL cosOD.wParam$	! WPARAM
LENGTH	MAX.STRING.LEN & LOCAL cosOD.lParam$	! LPARAM
LENGTH	WORD.S.LEN & LOCAL cosOD.ExtFlags$	! WORD
SET	cosODStrucBaseSize =  22		! No ExtFlags
SET	cosODStrucStringSize = 254		! 1*254
SET	cosODStrucSize	     = 278		! TOTAL

! For sending commands to COSW
cosOD:	Format	  _
	cosOD.Function$	; _
	cosOD.hDlg$	; _
	cosOD.Cmd$	; _
	cosOD.Flags$	; _
	cosOD.nID$	; _
	cosOD.Msg$	; _
	cosOD.wParam$	; _
	cosOD.lParam$


SET		MAX.TABI.TEXT.LEN = 200
.IFDEF	CF.TABCTRL.CODE
LENGTH	DWORD.S.LEN &	LOCAL TCItemStruc.Mask$
LENGTH	DWORD.S.LEN &	LOCAL TCItemStruc.State$
LENGTH	DWORD.S.LEN &	LOCAL TCItemStruc.StateMask$
LENGTH	MAX.TABI.TEXT.LEN & LOCAL TCItemStruc.Text$
LENGTH	DWORD.S.LEN &	LOCAL TCItemStruc.TextMax$
LENGTH	DWORD.S.LEN &	LOCAL TCItemStruc.Image$
LENGTH	DWORD.S.LEN &	LOCAL TCItemStruc.lParam32$
SET		TCItemSize = 224	! 200+24 <= 254
TCItemStruc:	Format _
		TCItemStruc.Mask$				; _
		TCItemStruc.State$			; _
		TCItemStruc.StateMask$		; _
		TCItemStruc.Text$				; _
		TCItemStruc.TextMax$			; _
		TCItemStruc.Image$			; _
		TCItemStruc.lParam32$

LENGTH	DWORD.S.LEN & LOCAL	TCItemStruc.TextPtr$
TCRawItemStruc:	Format _
		TCItemStruc.Mask$				; _
		TCItemStruc.State$			; _
		TCItemStruc.StateMask$		; _
		TCItemStruc.TextPtr$			; _
		TCItemStruc.TextMax$			; _
		TCItemStruc.Image$			; _
		TCItemStruc.lParam32$
Set	TCRawItemStructSize = 24
Set	TCNMActionCodeSize = 4		! UINT
Set	TCNMStructSize = 64			! cosNMHDR.LENGTH+TCNMActionCodeSize+TCRawItemStrucSize*2

.ENDIF	!CF.TABCTRL.CODE

.IFDEF	CF.TREEVIEW.CODE


SET		MAX.TCI.TEXT.LEN = 200
LENGTH	MAX.TCI.TEXT.LEN & LOCAL TVItemStruc.Text$
LENGTH	DWORD.S.LEN &	LOCAL TVItemStruc.Mask$
LENGTH	HANDLE.S.LEN &	LOCAL	TVItemStruc.hItem$
LENGTH	DWORD.S.LEN &	LOCAL TVItemStruc.State$
LENGTH	DWORD.S.LEN &	LOCAL TVItemStruc.StateMask$
LENGTH	DWORD.S.LEN &	LOCAL TVItemStruc.TextMax$
LENGTH	DWORD.S.LEN &	LOCAL TVItemStruc.Image$
LENGTH	DWORD.S.LEN &	LOCAL TVItemStruc.SelectedImage$
LENGTH	DWORD.S.LEN &	LOCAL TVItemStruc.Children$
LENGTH	DWORD.S.LEN &	LOCAL TVItemStruc.lParam32$
LENGTH	1 & 				LOCAL TVItemStruc.ExtraByte$
SET		TVItemSize = 236	! 200+36 <= 254
TVItemStruc:	Format _
		TVItemStruc.Mask$				; _
		TVItemStruc.hItem$			; _
		TVItemStruc.State$			; _
		TVItemStruc.StateMask$		; _
		TVItemStruc.Text$				; _
		TVItemStruc.TextMax$			; _
		TVItemStruc.Image$			; _
		TVItemStruc.SelectedImage$	; _
		TVItemStruc.Children$		; _
		TVItemStruc.lParam32$		; _
		TVItemStruc.ExtraByte$

! Raw TREEVIEWITEM (Text is a ptr)
LENGTH	DWORD.S.LEN & LOCAL	TVItemStruc.TextPtr$
TVRawItemStruc:	Format _
		TVItemStruc.Mask$				; _
		TVItemStruc.hItem$			; _
		TVItemStruc.State$			; _
		TVItemStruc.StateMask$		; _
		TVItemStruc.TextPtr$			; _
		TVItemStruc.TextMax$			; _
		TVItemStruc.Image$			; _
		TVItemStruc.SelectedImage$	; _
		TVItemStruc.Children$		; _
		TVItemStruc.lParam32$		; _
		TVItemStruc.ExtraByte$
Set	TVRawItemStrucSize = 40
Set	TVNMActionCodeSize = 4		! UINT
Set	TVNMStructSize = 96			! cosNMHDR.LENGTH+TVNMActionCodeSize+TVRawItemStrucSize*2

Set FM.SKIP.BYTE$		= "@00@"
Set FM.BYTE$			= "@01@"
Set FM.WORD$			= "@02@"
Set FM.DWORD$			= "@03@"
Set FM.STRINGPTR$		= "@04@"
Set FM.STRINGARRAY$		= "@05@"		! Followed by length word

!                       Action TVITEM(Old)         TVITEM(New)
!                         |       |                    |
Set FM.NMTREEVIEW$	 = "@030303030303030303030303030303030303030303@"

! Text$ included here
Set FM.NMTREEVIEW.SZ$ = "@030303030304030303030303030303040303030303@"
!FM.NMTREEVIEW$ = _	! NMHDR is excluded from this
!	"03"+ _							! Action
!	"03030303 04 0303030303"+ _	! TVITEM Structure (Old)
!	"03030303 04 0303030303"		! TVITEM Structure (New)


LENGTH	HANDLE.S.LEN & LOCAL	TCIStruc.hParent$
LENGTH	HANDLE.S.LEN & LOCAL	TCIStruc.hInsertAfter$

Set	TCIStrucSize = 244		! TVItemSize+8

TCIStruc:	Format _
		TCIStruc.hParent$				; _
		TCIStruc.hInsertAfter$		; _
		TVItemStruc.Mask$				; _
		TVItemStruc.hItem$			; _
		TVItemStruc.State$			; _
		TVItemStruc.StateMask$		; _
		TVItemStruc.Text$				; _
		TVItemStruc.TextMax$			; _
		TVItemStruc.Image$			; _
		TVItemStruc.SelectedImage$	; _
		TVItemStruc.Children$		; _
		TVItemStruc.lParam32$		; _
		TVItemStruc.ExtraByte$

.ENDIF	! CF.TREEVIEW.CODE

.IFDEF CF.DATETIME.CODE
! NMDTPICKER - notify codes
Set FM.NMDTPICKER.MIN$	= "@03030303@" ! NLHDR + FLAGS
Set FM.NMDTPICKER$		= "@030303030202020202020202@" ! NLHDR + FLAGS + SYSTEMTIME
.ENDIF


.IFDEF CF.LISTVIEW.CODE
! NMLISTVIEW = FM.NMHDR$+iItem+iSubItem+uNewState+uOldState+uChanged+ptActionL+ptActionH+lParam

! NMHDR is excluded from this
Set FM.NMLISTVIEW$		= "@0303030303030303030303@"
! NMLISTVIEW - minimum implimentation = iSubItem
Set FM.NMLISTVIEW.MIN$	= "@0303030303@" ! iSubItem

!typedef struct tagLVCOLUMNA
!{
!    UINT mask;
!    int fmt;
!    int cx;
!    LPSTR pszText;
!    int cchTextMax;
!    int iSubItem;
!    int iImage;
!    int iOrder;
!} LVCOLUMNA, FAR* LPLVCOLUMNA;

Length DWORD.S.LEN & Local LVStruct.Col$
Length DWORD.S.LEN & Local LVItemStruct.Mask$
Length DWORD.S.LEN & Local LVItemStruct.Format$
Length DWORD.S.LEN & Local LVItemStruct.Width$
Length DWORD.S.LEN & Local LVItemStruct.TextMax$
Length DWORD.S.LEN & Local LVItemStruct.State$
Length DWORD.S.LEN & Local LVItemStruct.StateMask$
Length DWORD.S.LEN & Local LVItemStruct.Item$
Length DWORD.S.LEN & Local LVItemStruct.SubItem$
Length DWORD.S.LEN & Local LVItemStruct.Indent$
Length DWORD.S.LEN & Local LVItemStruct.Image$
Length DWORD.S.LEN & Local LVItemStruct.Order$
Set MAX.LVC.TEXT.LEN = 200
Length MAX.LVC.TEXT.LEN & Local LVItemStruct.Text$
Set LVColumnSize = 232		! 200+32 <= 254

LVCStruct: Format _
		LVStruct.Col$;_
		LVItemStruct.Mask$;_
		LVItemStruct.Format$;_
		LVItemStruct.Width$;_
		LVItemStruct.Text$;_
		LVItemStruct.TextMax$;_
		LVItemStruct.SubItem$;_
		LVItemStruct.Image$;_
		LVItemStruct.Order$

Length DWORD.S.LEN & Local LVItemStruct.TextPtr$
Set LVRawColumnSize = 32	! 32 <= 254
LVCRawStruct: Format _
		LVItemStruct.Mask$;_
		LVItemStruct.Format$;_
		LVItemStruct.Width$;_
		LVItemStruct.TextPtr$;_
		LVItemStruct.TextMax$;_
		LVItemStruct.SubItem$;_
		LVItemStruct.Image$;_
		LVItemStruct.Order$

.ifdef JUNK
struct _HD_ITEM
{
    UINT    mask;
    int     cxy;
    LPSTR   pszText;
    HBITMAP hbm;
    int     cchTextMax;
    int     fmt;
    LPARAM  lParam;
    int     iImage;
    int     iOrder;
} HDITEM;

struct
{
    NMHDR   hdr;
    int     iItem;
    int     iButton;
    HDITEM FAR* pitem;
}  HD_NOTIFY;
.endif

Length DWORD.S.LEN & Local LVItemStruct.hBitMap$
Length DWORD.S.LEN & Local LVItemStruct.lParam$
LVHDItemStruct: Format _
		LVItemStruct.Mask$;_
		LVItemStruct.Width$;_
		LVItemStruct.TextPtr$;_
		LVItemStruct.hBitMap$;_
		LVItemStruct.TextMax$;_
		LVItemStruct.Format$;_
		LVItemStruct.lParam$;_
		LVItemStruct.Image$;_
		LVItemStruct.Order$
Set LVHDItemStructSize = 36
Set LVHDItemSize = 4
Set LVHDButtonSize = 4
Set LVHDNMStructSize = 56		! cosNMHDR.LENGTH + LVHDItemSize + LVHDButtonSize + LVHDItemStructSize

.ifdef JUNK
typedef struct _LVITEM {
    UINT mask;
    int iItem;
    int iSubItem;
    UINT state;
    UINT stateMask;
    LPTSTR pszText;
    int cchTextMax;
    int iImage;
    LPARAM lParam;
    int iIndent;
} LVITEM
.endif

LVIStruct: Format _
		LVItemStruct.Mask$;_
		LVItemStruct.Item$;_
		LVItemStruct.SubItem$;_
		LVItemStruct.State$;_
		LVItemStruct.StateMask$;_
		LVItemStruct.Text$;_
		LVItemStruct.TextMax$;_
		LVItemStruct.Image$;_
		LVItemStruct.lParam$;_
		LVItemStruct.Indent$

Set LVIStructSize = 236		! 200 + 36 <= 254

.ifdef JUNK
typedef struct tagNMITEMACTIVATE{
    int     iItem;
    int     iSubItem;
    UINT    uNewState;
    UINT    uOldState;
    UINT    uChanged;
    POINT   ptAction;
    LPARAM  lParam;
    UINT    uKeyFlags;
} NMITEMACTIVATE, FAR *LPNMITEMACTIVATE;
.endif
Length DWORD.S.LEN & Local LVItemStruct.NewState$
Length DWORD.S.LEN & Local LVItemStruct.OldState$
Length DWORD.S.LEN & Local LVItemStruct.Changed$
Length DWORD.S.LEN & Local LVItemStruct.PtAction$
Length DWORD.S.LEN & Local LVItemStruct.KeyFlags$

LVNMActivateStruct: Format _
		LVItemStruct.Item$;_
		LVItemStruct.SubItem$;_
		LVItemStruct.NewState$;_
		LVItemStruct.OldState$;_
		LVItemStruct.Changed$;_
		LVItemStruct.PtAction$;_
		LVItemStruct.lParam$;_
		LVItemStruct.KeyFlags$
Set LVNMActivateStructSize = 32
.ENDIF


.ENDIF	! COSWIND.DEFINED
! .LIST
*
