.IFNDEF COSTOLD.DEFINED
SET COSTOLE.DEFINED = 1	! Any value will do

SET TOOL.MAJOR.VER = 1	! Defined in COSW
SET TOOL.MINOR.VER = 0	! Defined in COSW

LENGTH	WORD.S.LEN   & LOCAL TOOL.ToolCount$
LENGTH	BYTE.S.LEN   & LOCAL TOOL.MajorToolVersion$, TOOL.MinorToolVersion$
TOOL.Header: Format 	TOOL.MajorToolVersion$; _
			TOOL.MinorToolVersion$; _
			TOOL.ToolCount$
SET TOOL.HDR.SIZE = 4

SET TOOL.BubbleDelim$ = "@0A@"

! Tool Item Record
LENGTH	WORD.S.LEN   & LOCAL TOOL.RecSize$	! Size of this record
LENGTH	BYTE.S.LEN   & LOCAL TOOL.RecType$	! What this record contains
  SET TOOL.REC.STRING = 0
  SET TOOL.REC.MENU   = 1
  SET TOOL.REC.TOOL   = 2
  SET TOOL.REC.ACCEL  = 3
  SET TOOL.REC.TOOL.EX = 4	! Toolbar with dual bitmaps
LENGTH	WORD.S.LEN   & LOCAL TOOL.nID$		! Equivalent resource ID
LENGTH	WORD.S.LEN   & LOCAL TOOL.Flags$		! Menu/Tool attributes
LENGTH	WORD.S.LEN   & LOCAL TOOL.ItemBytesSize$	! Number of bytes in array
SET TOOL.ITEM.SIZE = 9
LENGTH	MAX.STRING.LEN & LOCAL TOOL.ItemBytes$	! Menu text / Status bar text+(\n)+Tool tip text
LENGTH	MAX.STRING.LEN & LOCAL TOOL.ItemBytes2$ ! Menu text / Status bar text+(\n)+Tool tip text
LENGTH	MAX.STRING.LEN & LOCAL TOOL.ItemBytes3$ ! Menu text / Status bar text+(\n)+Tool tip text
LENGTH	253            & LOCAL TOOL.ItemBytes4$ ! Menu text / Status bar text+(\n)+Tool tip text
SET TOTAL.TOOL.REC.SIZE = 1024
TOOL.Record: Format 	TOOL.RecSize$; _
			TOOL.RecType$; _
			TOOL.nID$; _
			TOOL.Flags$; _
			TOOL.ItemBytesSize$; _
			TOOL.ItemBytes$; _
			TOOL.ItemBytes2$; _
			TOOL.ItemBytes3$; _
			TOOL.ItemBytes4$

SET TOOL.BMP.SIZE1 = 238	! 16*15
SET TOOL.BMP.SIZE2 = 246	! 16*16
SET TOOL.BMP.SIZE3 = 630	! 32*32
SET TOOL.LARGEST.BMP.SIZE = 630 ! TOOL.BMP.SIZE3
SET TOOL.COMBINED.BMP.SIZE = 876 ! TOOL.BMP.SIZE3 + TOOL.BMP.SIZE2

SET TOOL.MODE.REPLACE	= 0
SET TOOL.MODE.PUSH	= 1
SET TOOL.MODE.POP	= 2
SET TOOL.MODE.POPALL	= 3
SET TOOL.MODE.INQUIRE	= 4

SET TOOL.ID.FIRST	= 40001	! First available NOVA ID (nova-33)
SET TOOL.ID.LAST	= 40200	! Last available NOVA ID (nova-133)

.ENDIF	! COSTOLD.DEFINED

